
species Ectatomma Ruidum Roger {polygyny true}
graphics generic.bmp {size 20}
{worker 8
worker+egg 8
worker+larva 8
worker+food 8
queen 8
queen+egg 8
queen+larva 8
queen+food 8
cocoon 1
egg 1
larva 1
}
--- Definition of AntClass class    ---
class AntClass {system TMovingAgent type worker }
--- Definition of AntClass variables ---
var carryingCapacity {min 15.000 max 15.000 init 15.000 value 15.000 increment 0.000 delta 0.000}
var cureLevel {min 0.000 max 30.000 init 15.000 value -1.000 increment -0.002 delta 0.000}
var foodLevel {min 3.000 max 30.000 init 16.000 value -1.000 increment -0.002 delta 2.000}
var lifeTime {min 0.000 max 6000000.000 init 0.000 value -1.000 increment 1.000 delta 0.000}
--- Definition of AntClass stimuli   ---
stim cure_self {range internal type fixed}
	{value 8.000}
stim default {range internal type fixed}
	{value 1.000}
stim hungry_self {range internal type threshold}
	{if (value[foodLevel] < (init[foodLevel] / 3.000))
	then 100.000
	else ((init[foodLevel] - value[foodLevel]) * 2.000)}
stim kill_egg {range internal type threshold}
	{if ((value[foodLevel] < (init[foodLevel] / 2.000)) & (((stim[loc_egg] > 0.000) | (stim[cure_egg] > 0.000)) & (stim[food] = 0.000)))
	then 10000.000
	else 0.000}
stim kill_larva {range internal type threshold}
	{if ((value[foodLevel] < (init[foodLevel] / 2.000)) & ((stim[loc_larva] > 0.000) & (stim[food] = 0.000)))
	then 500.000
	else 0.000}
stim maturing_self {range internal type threshold}
	{if ((value[foodLevel] = 0.000) | ((value[cureLevel] = 0.000) | (value[lifeTime] = max[lifeTime])))
	then 1000.000
	else 0.000}
--- Definition of AntClass tasks     ---
task cure_cocoon {weight 48 threshold 180 initialthreshold 180.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_cocoon)
repeat cure(cure_cocoon)
}
task cure_egg {weight 8 threshold 30 initialthreshold 30.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_egg)
repeat cure(cure_egg)
}
task cure_larva {weight 16 threshold 60 initialthreshold 60.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_larva)
repeat cure(cure_larva)
}
task cure_self {weight 8 threshold 30 initialthreshold 30.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat cure()
do eat()
do kill(egg)
}
task default {weight 1 threshold 0 initialthreshold 0.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 0.000 activationlevel 0.000 execmark 0}
{repeat move()
}
task hungry_larva {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_food food)
repeat eat(food)
do carryOne(food)
repeat follow(hungry_larva humidity)
stop putDown(food)
}
task hungry_self {weight 2 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_food food)
repeat eat(food)
do carryOne(food)
repeat follow(humidity)
stop putDown(food)
}
task kill_egg {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_egg)
do kill(egg)
}
task kill_larva {weight 10 threshold 20 initialthreshold 20.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_larva hungry_larva)
do kill(larva)
}
task light {weight   0.7500 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement -0.100 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(humidity -light)
}
task maturing_self {weight 4 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{do mature()
}
task move_cocoon {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_cocoon)
do carry(move_cocoon)
repeat follow(move_cocoon -humidity -light)
stop putDown(cocoon)
}
task move_egg {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_egg)
do carry(move_egg)
repeat follow(move_egg humidity -move_larva)
stop putDown(egg)
}
task move_larva {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_larva)
do carry(move_larva)
repeat follow(-move_egg humidity move_larva -light)
stop putDown(larva)
}

endClass AntClass
--- Definition of CocoonClass class    ---
class CocoonClass {system TBroodAgent type cocoon  next AntClass }
--- Definition of CocoonClass variables ---
var cureLevel {min 0.000 max 30.000 init 25.000 value -1.000 increment -0.001 delta 0.000}
var lifeTime {min 0.000 max 334080.000 init 0.000 value -1.000 increment 1.000 delta 46080.000}
--- Definition of CocoonClass stimuli   ---
stim cure_cocoon {range external type normal}
	{value (init[cureLevel] - value[cureLevel])}
stim default {range internal type fixed}
	{value 1.000}
stim maturing_cocoon {range internal type threshold}
	{if ((value[cureLevel] = 0.000) | (value[lifeTime] = max[lifeTime]))
	then 10000.000
	else 0.000}
stim move_cocoon {range external type increment}
	{step ((0.001 * stim[humidity]) + (0.003 * stim[light]))
	min 0.001 max 0.100}
--- Definition of CocoonClass tasks     ---
task maturing_cocoon {weight 4 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{do mature()
}

endClass CocoonClass
--- Definition of EggClass class    ---
class EggClass {system TBroodAgent type egg  next LarvaClass }
--- Definition of EggClass variables ---
var cureLevel {min 0.000 max 30.000 init 15.000 value -1.000 increment -0.003 delta 1.000}
var lifeTime {min 0.000 max 253440.000 init 0.000 value -1.000 increment 1.000 delta 3840.000}
--- Definition of EggClass stimuli   ---
stim cure_egg {range external type normal}
	{value (init[cureLevel] - value[cureLevel])}
stim default {range internal type fixed}
	{value 1.000}
stim loc_egg {range external type fixed}
	{value 1.000}
stim maturing_egg {range internal type threshold}
	{if ((value[cureLevel] = 0.000) | (value[lifeTime] = max[lifeTime]))
	then 10000.000
	else 0.000}
stim move_egg {range external type increment}
	{step (0.050 / stim[humidity])
	min 0.001 max 0.100}
--- Definition of EggClass tasks     ---
task maturing_egg {weight 4 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{do mature()
}

endClass EggClass
--- Definition of LarvaClass class    ---
class LarvaClass {system TBroodAgent type larva  next CocoonClass }
--- Definition of LarvaClass variables ---
var cureLevel {min 0.000 max 30.000 init 15.000 value -1.000 increment -0.002 delta 1.000}
var foodLevel {min 0.000 max 30.000 init 16.000 value -1.000 increment -0.002 delta 1.000}
var lifeTime {min 0.000 max 212428.000 init 0.000 value -1.000 increment 1.000 delta 11520.000}
--- Definition of LarvaClass stimuli   ---
stim cure_larva {range external type normal}
	{value (init[cureLevel] - value[cureLevel])}
stim default {range internal type fixed}
	{value 1.000}
stim hungry_larva {range external type normal}
	{value ((init[foodLevel] - value[foodLevel]) * 1.500)}
stim loc_larva {range external type fixed}
	{value 1.000}
stim maturing_larva {range internal type threshold}
	{if ((value[foodLevel] = 0.000) | ((value[cureLevel] = 0.000) | (value[lifeTime] = max[lifeTime])))
	then 10000.000
	else 0.000}
stim move_larva {range external type increment}
	{step ((0.050 / stim[humidity]) + (0.003 * stim[light]))
	min 0.001 max 0.100}
--- Definition of LarvaClass tasks     ---
task hungry_larva {weight 4 threshold 4 initialthreshold 4.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat eat(food)
}
task maturing_larva {weight 4 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{do mature()
}

endClass LarvaClass
--- Definition of QueenClass class    ---
class QueenClass {system TReproductiveAgent type queen  extends AntClass  gives EggClass }
--- Definition of QueenClass variables ---
var carryingCapacity {min 15.000 max 15.000 init 15.000 value 15.000 increment 0.000 delta 0.000}
var cureLevel {min 0.000 max 30.000 init 15.000 value -1.000 increment -0.002 delta 0.000}
var foodLevel {min 3.000 max 30.000 init 16.000 value -1.000 increment -0.002 delta 2.000}
var lifeTime {min 0.000 max 6000000.000 init 0.000 value -1.000 increment 1.000 delta 0.000}
var reproducingInterval {min 0.000 max 6776.000 init 6776.000 value -1.000 increment -1.000 delta 100.000}
--- Definition of QueenClass stimuli   ---
stim cure_self {range internal type fixed}
	{value 8.000}
stim default {range internal type fixed}
	{value 1.000}
stim hungry_self {range internal type threshold}
	{if (value[foodLevel] < (init[foodLevel] / 3.000))
	then 100.000
	else ((init[foodLevel] - value[foodLevel]) * 2.000)}
stim kill_egg {range internal type threshold}
	{if ((value[foodLevel] < (init[foodLevel] / 2.000)) & (((stim[loc_egg] > 0.000) | (stim[cure_egg] > 0.000)) & (stim[food] = 0.000)))
	then 10000.000
	else 0.000}
stim kill_larva {range internal type threshold}
	{if ((value[foodLevel] < (init[foodLevel] / 2.000)) & ((stim[loc_larva] > 0.000) & (stim[food] = 0.000)))
	then 500.000
	else 0.000}
stim layEggs_queen {range internal type threshold}
	{if ((value[reproducingInterval] = 0.000) & (value[foodLevel] > 4.000))
	then 1000.000
	else 0.000}
stim maturing_self {range internal type threshold}
	{if ((value[foodLevel] = 0.000) | ((value[cureLevel] = 0.000) | (value[lifeTime] = max[lifeTime])))
	then 1000.000
	else 0.000}
--- Definition of QueenClass tasks     ---
task cure_cocoon {weight 48 threshold 180 initialthreshold 180.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_cocoon)
repeat cure(cure_cocoon)
}
task cure_egg {weight 8 threshold 30 initialthreshold 30.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_egg)
repeat cure(cure_egg)
}
task cure_larva {weight 16 threshold 60 initialthreshold 60.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(cure_larva)
repeat cure(cure_larva)
}
task cure_self {weight 8 threshold 30 initialthreshold 30.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat cure()
}
task default {weight 1 threshold 0 initialthreshold 0.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 0.000 activationlevel 0.000 execmark 0}
{repeat move()
}
task hungry_larva {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_food food)
repeat eat(food)
do carryOne(food)
repeat follow(hungry_larva humidity)
stop putDown(food)
}
task hungry_self {weight 2 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_food food)
repeat eat(food)
do carryOne(food)
repeat follow(humidity)
stop putDown(food)
}
task kill_egg {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_egg)
do kill(egg)
}
task kill_larva {weight 10 threshold 20 initialthreshold 20.000 activitylevel 0.000 weightincrement 0.000 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(loc_larva hungry_larva)
do kill(larva)
}
task layEggs_queen {weight 100 threshold 0 initialthreshold 0.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(humidity move_egg cure_egg)
stop reproduce()
}
task light {weight   0.7500 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement -0.050 thresholdincrement 0.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(humidity -light)
}
task maturing_self {weight 4 threshold 10 initialthreshold 10.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{do mature()
}
task move_cocoon {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_cocoon)
do carry(move_cocoon)
repeat follow(move_cocoon -humidity -light)
stop putDown(cocoon)
}
task move_egg {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_egg)
do carry(move_egg)
repeat follow(move_egg humidity -move_larva)
stop putDown(egg)
}
task move_larva {weight 4 threshold 15 initialthreshold 15.000 activitylevel 0.000 weightincrement 0.100 thresholdincrement 1.000 thresholddecrement 0.500 activityleveldecrement 1.000 activationlevel 0.000 execmark 0}
{repeat follow(move_larva)
do carry(move_larva)
repeat follow(-move_egg humidity move_larva -light)
stop putDown(larva)
}

endClass QueenClass
